#define _WIN32_WINNT 0x0501

#include <windows.h>
#include <stdio.h>
#include <shlwapi.h>
#include <strsafe.h>
#include <Winternl.h>

#define FILE_SUPERSEDE                  0x00000000
#define FILE_OPEN                       0x00000001
#define FILE_CREATE						0x00000002

#define FILE_SYNCHRONOUS_IO_ALERT		0x00000010
#define FILE_NO_EA_KNOWLEDGE			0x00000200
#define FILE_RANDOM_ACCESS				0x00000800

#define FILE_SUPERSEDED                 0x00000000
#define FILE_OPENED                     0x00000001
#define FILE_CREATED                    0x00000002
#define FILE_OVERWRITTEN                0x00000003
#define FILE_EXISTS                     0x00000004
#define FILE_DOES_NOT_EXIST             0x00000005

#define FILE_USE_FILE_POINTER_POSITION  0xfffffffe

#define OBJ_INHERIT             0x00000002L
#define OBJ_PERMANENT           0x00000010L
#define OBJ_EXCLUSIVE           0x00000020L
#define OBJ_CASE_INSENSITIVE    0x00000040L
#define OBJ_OPENIF              0x00000080L
#define OBJ_OPENLINK            0x00000100L
#define OBJ_KERNEL_HANDLE       0x00000200L
#define OBJ_FORCE_ACCESS_CHECK  0x00000400L
#define OBJ_VALID_ATTRIBUTES    0x000007F2L

VOID (__stdcall *_RtlInitUnicodeString)(PUNICODE_STRING DestinationString, PCWSTR SourceString);
int (__stdcall *_ZwCreateFile)(PHANDLE FileHandle, ACCESS_MASK DesiredAccess, POBJECT_ATTRIBUTES ObjectAttributes, PIO_STATUS_BLOCK IoStatusBlock, PLARGE_INTEGER AllocationSize, ULONG FileAttributes, ULONG ShareAccess, ULONG CreateDisposition, ULONG CreateOptions, PVOID EaBuffer, ULONG EaLength);
int (__stdcall *_ZwReadFile)(HANDLE FileHandle, HANDLE  Event, PIO_APC_ROUTINE  ApcRoutine, PVOID  ApcContext, PIO_STATUS_BLOCK IoStatusBlock, PVOID Buffer, ULONG  Length, PLARGE_INTEGER  ByteOffset, PULONG  Key);
int (__stdcall *_ZwWriteFile)(HANDLE FileHandle, HANDLE  Event, PIO_APC_ROUTINE  ApcRoutine, PVOID  ApcContext, PIO_STATUS_BLOCK IoStatusBlock, PVOID Buffer, ULONG  Length, PLARGE_INTEGER  ByteOffset, PULONG  Key);
int (__stdcall *_ZwClose)(HANDLE  Handle);
int (__stdcall *_ZwQuerySymbolicLinkObject)(HANDLE LinkHandle, PUNICODE_STRING LinkTarget, PULONG ReturnedLength);
int (__stdcall *_ZwOpenSymbolicLinkObject)(PHANDLE  LinkHandle, ACCESS_MASK  DesiredAccess, POBJECT_ATTRIBUTES  ObjectAttributes);

#ifdef _UNICODE
int wmain(int argc, WCHAR* argv[]) {
#else
int main(int argc, CHAR* argv[]) {
#endif
	TCHAR Src[MAX_PATH], Dst[MAX_PATH], SrcLinkData[MAX_PATH], DstLinkData[MAX_PATH], LinkData[MAX_PATH];
	UNICODE_STRING SrcName, DstName, SrcLink, DstLink, Link;
	TCHAR OpDir[MAX_PATH], Temp[MAX_PATH], SrcDrive[8], DstDrive[8], Drive[8], ErrBuffer[MAX_PATH];
	HANDLE hFileIn = 0, hFileOut = 0, hFileQuery = 0;
	BYTE IoBuffer[16384];
	DWORD Nr, Nw, Sz, IoPtr;
	TCHAR ConBuffer[1024];
	OBJECT_ATTRIBUTES ObjIn, ObjOut, ObjQuery;
	IO_STATUS_BLOCK IoStatIn, IoStatOut, IoStatQuery;
	HMODULE hLib;
	int Status;
	
	if (argc < 3) {
		StringCbPrintf(ConBuffer, sizeof(ConBuffer), TEXT("Usage:\nntfscp <source> <destination>\nAttention: Filenames are case sensitive!"));
		WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), ConBuffer, lstrlen(ConBuffer), &Nw, NULL);
		return 0;
	}

	hLib = GetModuleHandle(TEXT("ntdll.dll"));
	_RtlInitUnicodeString = GetProcAddress(hLib, "RtlInitUnicodeString");
	_ZwCreateFile = GetProcAddress(hLib, "ZwCreateFile");
	_ZwReadFile = GetProcAddress(hLib, "ZwReadFile");
	_ZwWriteFile = GetProcAddress(hLib, "ZwWriteFile");
	_ZwClose = GetProcAddress(hLib, "ZwClose");
	_ZwQuerySymbolicLinkObject = GetProcAddress(hLib, "ZwQuerySymbolicLinkObject");
	_ZwOpenSymbolicLinkObject = GetProcAddress(hLib, "ZwOpenSymbolicLinkObject");
	
	PathRemoveFileSpec(argv[0]);

	ObjQuery.Length = sizeof(OBJECT_ATTRIBUTES);
	ObjQuery.Attributes = OBJ_KERNEL_HANDLE | OBJ_CASE_INSENSITIVE;
	ObjQuery.RootDirectory = NULL;
	ObjQuery.SecurityDescriptor = NULL;
	ObjQuery.SecurityQualityOfService = NULL;
	
	/* Set default drive strings */
	StrCpy(Drive, TEXT("\\??\\C:"));
	StrCpy(SrcDrive, TEXT("\\??\\C:"));
	StrCpy(DstDrive, TEXT("\\??\\C:"));
	
	if (lstrlen(argv[0]) == 0) {
		GetCurrentDirectory(sizeof(Temp) / sizeof(TCHAR), Temp);
	} else {
		StrCpy(Temp, argv[0]);
	}
	Drive[4] = PathGetDriveNumber(Temp) + 65;
	
	_RtlInitUnicodeString(&Link, Drive);
	ObjQuery.ObjectName = &Link;
	Status = _ZwOpenSymbolicLinkObject(&hFileQuery, GENERIC_READ, &ObjQuery);
	Link.Buffer = LinkData;
	Link.Length = 0;
	Link.MaximumLength = sizeof(LinkData) / sizeof(TCHAR);
	Status = _ZwQuerySymbolicLinkObject(hFileQuery, &Link, &Sz);
	_ZwClose(hFileQuery);

	StrCpy(OpDir, LinkData);
	StrCat(OpDir, TEXT("\\"));
	StrCat(OpDir, PathSkipRoot(Temp));
	StrCat(OpDir, TEXT("\\"));
	
	if (PathIsRelative(argv[1])) {
		StrCpy(Src, OpDir);
		StrCat(Src, argv[1]);
	} else {
		SrcDrive[4] = PathGetDriveNumber(argv[1]) + 65;
		_RtlInitUnicodeString(&SrcLink, SrcDrive);
		ObjQuery.ObjectName = &SrcLink;
		Status = _ZwOpenSymbolicLinkObject(&hFileQuery, GENERIC_READ, &ObjQuery);
		SrcLink.Buffer = SrcLinkData;
		SrcLink.MaximumLength = sizeof(SrcLinkData) / sizeof(TCHAR);
		SrcLink.Length = 0;
		Status = _ZwQuerySymbolicLinkObject(hFileQuery, &SrcLink, &Sz);
		hFileQuery = 0;
		
		StrCpy(Src, SrcLink.Buffer);
		StrCat(Src, TEXT("\\"));
		StrCat(Src, PathSkipRoot(argv[1]));
	}
	if (PathIsRelative(argv[2])) {
		StrCpy(Dst, OpDir);
		StrCat(Dst, argv[2]);
	} else {
		DstDrive[4] = PathGetDriveNumber(argv[2]) + 65;
		_RtlInitUnicodeString(&DstLink, DstDrive);
		ObjQuery.ObjectName = &DstLink;
		Status = _ZwOpenSymbolicLinkObject(&hFileQuery, GENERIC_READ, &ObjQuery);
		DstLink.Buffer = DstLinkData;
		DstLink.Length = 0;
		DstLink.MaximumLength = sizeof(DstLinkData) / sizeof(TCHAR);
		Status = _ZwQuerySymbolicLinkObject(hFileQuery, &DstLink, &Sz);
		_ZwClose(hFileQuery);
		
		StrCpy(Dst, DstLink.Buffer);
		StrCat(Dst, TEXT("\\"));
		StrCat(Dst, PathSkipRoot(argv[2]));
	}

	StringCbPrintf(ConBuffer, sizeof(ConBuffer), TEXT("src=%s\ndst=%s\n\n"), Src, Dst);
	WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), ConBuffer, lstrlen(ConBuffer), &Nw, NULL);
	
	_RtlInitUnicodeString(&SrcName, Src);
	_RtlInitUnicodeString(&DstName, Dst);
	
	ObjIn.Length = sizeof(OBJECT_ATTRIBUTES);
	ObjIn.Attributes = OBJ_KERNEL_HANDLE;
	ObjIn.RootDirectory = NULL;
	ObjIn.SecurityDescriptor = NULL;
	ObjIn.SecurityQualityOfService = NULL;
	ObjIn.ObjectName = &SrcName;
	
	CopyMemory(&ObjOut, &ObjIn, sizeof(ObjIn));
	ObjOut.ObjectName = &DstName;
	
	ZeroMemory(&IoStatIn, sizeof(IoStatIn));
	ZeroMemory(&IoStatOut, sizeof(IoStatOut));
	
	Status = _ZwCreateFile(&hFileIn, SYNCHRONIZE | GENERIC_READ, &ObjIn, &IoStatIn, 0, 0, 0, FILE_OPEN, FILE_SYNCHRONOUS_IO_ALERT, NULL, 0);
	if (Status != 0) {
		StringCbPrintf(ConBuffer, sizeof(ConBuffer), TEXT("Error openning, Status=%x\n"), Status);
		WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), ConBuffer, lstrlen(ConBuffer), &Nw, NULL);
		getchar();
		return 0;
	}

	Status = _ZwCreateFile(&hFileOut, SYNCHRONIZE | GENERIC_WRITE, &ObjOut, &IoStatOut, 0, 0, 0, FILE_CREATE, FILE_SYNCHRONOUS_IO_ALERT, NULL, 0);
	if (Status != 0) {
		StringCbPrintf(ConBuffer, sizeof(ConBuffer), TEXT("Error creating, Status=%x (%x)\n"), Status, IoStatOut.Status);
		WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), ConBuffer, lstrlen(ConBuffer), &Nw, NULL);
		getchar();
		return 0;
	}
	
	Sz = GetFileSize(hFileIn, NULL);
	IoPtr = 0;
	do {
		Status = _ZwReadFile(hFileIn, NULL, NULL, NULL, &IoStatIn, IoBuffer, sizeof(IoBuffer), 0, NULL);
		Nr = IoStatIn.Information;
		if (Status == 0) {
			Status = _ZwWriteFile(hFileOut, NULL, NULL, NULL, &IoStatOut, IoBuffer, Nr, 0, NULL);
		}
		
	} while (Nr == sizeof(IoBuffer));
	CloseHandle(hFileIn);
	CloseHandle(hFileOut);
getchar();
	return 0;
}